module Gdas::Assets::Aws::ELBV2
  module Context
    extend ::ActiveSupport::Concern

    included do
      class << self
        def service
          # This is odd based on folder structure, but it's because ALBs and NLBs were added under the EC2 service.
          # They needed to be extracted from the +ec2+ directory because they have a different API endpoint.
          'ec2'
        end
      end
    end
  end
end
