# frozen_string_literal: true

module Gdas::Assets::Azure::VirtualNetwork
  module Context
    extend ::ActiveSupport::Concern

    included do
      class << self
        # Used the service listed in the API docs:
        # https://learn.microsoft.com/en-us/rest/api/virtualnetwork/virtual-networks
        def service
          'virtual_network'
        end
      end
    end
  end
end
