# frozen_string_literal: true
module Gdas
  module Collection
    class AzureDerivedCollector < DerivedCollector
      class << self

        def cloud_name
          ::Gdas::Clouds::AzureCloudConfig::CLOUD_NAME
        end

        def gdas_artifact_name
          'gdas_azure_artifact'
        end

      end
    end
  end
end
