# frozen_string_literal: true

module Gdas
  module Scheduler
    class JobStatsGenScheduler < ::CloudHealth::JobManagement::Scheduling::JobStatsGenScheduler
      register({ "derived_process" => Gdas::JobMgmt::DerivedProcessorTokenLock.supported_owners },
               ImportRegistry.resolve('cache.redis_job_tokens'),
               ImportRegistry.resolve('job_token_mgr'),
               ImportRegistry.resolve('logger'),
               ImportRegistry.resolve('statsd'))
    end
  end
end
