# frozen_string_literal: true

module Gdas
  module Workers
    class AwsGdasWorker < ::CloudHealth::Collection::Workers::StandardWorker
      sidekiq_options queue: :collection_assets_aws_gdas, retry: 2
    end

    class AzureGdasWorker < ::CloudHealth::Collection::Workers::StandardWorker
      sidekiq_options queue: :collection_assets_azure_gdas, retry: 2
    end
  end
end
