# frozen_string_literal: true

require_relative 'aws_tag'
require_relative 'aws_tag_override'
require_relative '../generic_derived_asset'

class AwsAssetBase < GenericDerivedAsset
  self.abstract_class = true

  self.account_attr = :aws_account_id
  self.tag_model = ::AwsTag
  self.tag_override_model = ::AwsTagOverride
  self.tag_relation = "aws_tags"
  self.cloud = ::Gdas::Clouds::AwsCloudConfig::CLOUD_NAME
end
