class AwsTag < ActiveRecord::Base
  belongs_to :customer

  has_and_belongs_to_many :aws_accounts, join_table: :aws_accounts_aws_tags
  has_and_belongs_to_many :aws_auto_scaling_groups, join_table: :aws_auto_scaling_groups_aws_tags
  # has_and_belongs_to_many :aws_cache_clusters, join_table: :aws_cache_clusters_aws_tags
  # has_and_belongs_to_many :aws_cloud_formation_stacks, join_table: :aws_cloud_formation_stacks_aws_tags
  has_and_belongs_to_many :aws_dynamo_db_tables, join_table: :aws_dynamo_db_tables_aws_tags
  has_and_belongs_to_many :aws_emr_clusters, join_table: :aws_emr_clusters_aws_tags
  has_and_belongs_to_many :aws_elasticsearch_domains, join_table: :aws_es_aws_tags
  has_and_belongs_to_many :aws_images, join_table: :aws_images_aws_tags
  # has_and_belongs_to_many :aws_instance_reservations, join_table: :aws_instance_reservations_aws_tags
  has_and_belongs_to_many :aws_instances, join_table: :aws_instances_aws_tags
  has_and_belongs_to_many :aws_lambda_function, join_table: :aws_lambda_functions_aws_tags
  has_and_belongs_to_many :aws_load_balancers, join_table: :aws_load_balancers_aws_tags
  has_and_belongs_to_many :aws_rds_instance_reservations, join_table: :aws_rds_instance_reservations_aws_tags
  has_and_belongs_to_many :aws_rds_instances, join_table: :aws_rds_instances_aws_tags
  has_and_belongs_to_many :aws_rds_security_groups, join_table: :aws_rds_security_groups_aws_tags
  has_and_belongs_to_many :aws_redshift_clusters, join_table: :aws_redshift_clusters_aws_tags
  has_and_belongs_to_many :aws_route53_hosted_zones, join_table: :aws_route53_hosted_zones_aws_tags
  has_and_belongs_to_many :aws_s3_buckets, join_table: :aws_s3_buckets_aws_tags
  has_and_belongs_to_many :aws_security_groups, join_table: :aws_security_groups_aws_tags
  # has_and_belongs_to_many :aws_snapshots, join_table: :aws_snapshots_aws_tags
  has_and_belongs_to_many :aws_spot_requests, join_table: :aws_spot_requests_aws_tags
  has_and_belongs_to_many :aws_volumes, join_table: :aws_tags_aws_volumes
  has_and_belongs_to_many :aws_vpc_subnets, join_table: :aws_tags_aws_vpc_subnets
  has_and_belongs_to_many :aws_vpcs, join_table: :aws_tags_aws_vpcs
  has_and_belongs_to_many :aws_rds_subnet_groups, join_table: :aws_rds_subnet_groups_aws_tags
  has_and_belongs_to_many :aws_dms_replication_instances, join_table: :aws_dms_replication_instances_aws_tags
  has_and_belongs_to_many :aws_sqs_queues, join_table: :aws_sqs_queues_aws_tags
  has_and_belongs_to_many :aws_data_pipeline_pipelines, join_table: :aws_data_pipeline_pipelines_aws_tags
  has_and_belongs_to_many :aws_cloudhsm_hsms, join_table: :aws_cloudhsm_hsms_aws_tags
  has_and_belongs_to_many :aws_cognito_user_pools, join_table: :aws_cognito_user_pools_aws_tags
  has_and_belongs_to_many :aws_direct_connect_connections, join_table: :aws_direct_connect_connections_aws_tags
  has_and_belongs_to_many :aws_direct_connect_virtual_interfaces, join_table: :aws_direct_connect_virtual_interfaces_aws_tags
  has_and_belongs_to_many :aws_glacier_vaults, join_table: :aws_glacier_vaults_aws_tags
  has_and_belongs_to_many :aws_cloud_directory_directories, join_table: :aws_cloud_directory_directories_aws_tags
  has_and_belongs_to_many :aws_cloud_search_domains, join_table: :aws_cloud_search_domains_aws_tags
  has_and_belongs_to_many :aws_kinesis_video_streams, join_table: :aws_kinesis_video_streams_aws_tags
  has_and_belongs_to_many :aws_kinesis_streams, join_table: :aws_kinesis_streams_aws_tags
  has_and_belongs_to_many :aws_route53_health_checks, join_table: :aws_route53_health_checks_aws_tags
  has_and_belongs_to_many :aws_dynamo_db_accelerator_clusters, join_table: :aws_dynamo_db_accelerator_clusters_aws_tags

  has_and_belongs_to_many :aws_app_stream_image_builders, join_table: :aws_app_stream_image_builders_aws_tags
  has_and_belongs_to_many :aws_app_stream_fleets, join_table: :aws_app_stream_fleets_aws_tags
  has_and_belongs_to_many :aws_machine_learning_batch_predictions, join_table: :aws_machine_learning_batch_predictions_aws_tags
  has_and_belongs_to_many :aws_machine_learning_datasources, join_table: :aws_machine_learning_datasources_aws_tags
  has_and_belongs_to_many :aws_machine_learning_evaluations, join_table: :aws_machine_learning_evaluations_aws_tags
  has_and_belongs_to_many :aws_machine_learning_ml_models, join_table: :aws_machine_learning_ml_models_aws_tags
  has_and_belongs_to_many :aws_code_build_projects, join_table: :aws_code_build_projects_aws_tags
  has_and_belongs_to_many :aws_api_gateway_stages, join_table: :aws_api_gateway_stages_aws_tags
  has_and_belongs_to_many :aws_ec2_application_load_balancers, join_table: :aws_ec2_application_load_balancers_aws_tags
  has_and_belongs_to_many :aws_ec2_network_load_balancers, join_table: :aws_ec2_network_load_balancers_aws_tags
  has_and_belongs_to_many :aws_directory_service_directories, join_table: :aws_directory_service_directories_aws_tags
  has_and_belongs_to_many :aws_alexa_for_business_devices, join_table: :aws_alexa_for_business_devices_aws_tags
  has_and_belongs_to_many :aws_alexa_for_business_users, join_table: :aws_alexa_for_business_users_aws_tags
  has_and_belongs_to_many :aws_iot_analytics_channels, join_table: :aws_iot_analytics_channels_aws_tags
  has_and_belongs_to_many :aws_iot_analytics_pipelines, join_table: :aws_iot_analytics_pipelines_aws_tags
  has_and_belongs_to_many :aws_iot_analytics_datastores, join_table: :aws_iot_analytics_datastores_aws_tags
  has_and_belongs_to_many :aws_iot_analytics_datasets, join_table: :aws_iot_analytics_datasets_aws_tags
  has_and_belongs_to_many :aws_storage_gateway_file_shares, join_table: :aws_storage_gateway_file_shares_aws_tags
  has_and_belongs_to_many :aws_storage_gateway_tapes, join_table: :aws_storage_gateway_tapes_aws_tags
  has_and_belongs_to_many :aws_storage_gateway_volume_gateways, join_table: :aws_storage_gateway_volume_gateways_aws_tags
  has_and_belongs_to_many :aws_secrets_manager_secrets, join_table: :aws_secrets_manager_secrets_aws_tags
  has_and_belongs_to_many :aws_glue_development_endpoints, join_table: :aws_glue_development_endpoints_aws_tags
  has_and_belongs_to_many :aws_glue_jobs, join_table: :aws_glue_jobs_aws_tags
  has_and_belongs_to_many :aws_glue_crawlers, join_table: :aws_glue_crawlers_aws_tags
  has_and_belongs_to_many :aws_lex_bots, join_table: :aws_lex_bots_aws_tags
  has_and_belongs_to_many :aws_cm_certificates, join_table: :aws_cm_certificates_aws_tags
  has_and_belongs_to_many :aws_cm_certificate_authorities, join_table: :aws_cm_certificate_authorities_aws_tags
  has_and_belongs_to_many :aws_waf_rules, join_table: :aws_waf_rules_aws_tags
  has_and_belongs_to_many :aws_waf_webacls, join_table: :aws_waf_webacls_aws_tags
  has_and_belongs_to_many :aws_shield_protections, join_table: :aws_shield_protections_aws_tags
  has_and_belongs_to_many :aws_shield_subscriptions, join_table: :aws_shield_subscriptions_aws_tags
  has_and_belongs_to_many :aws_simple_email_service_dedicated_ips, join_table: :aws_simple_email_service_dedicated_ips_aws_tags
  has_and_belongs_to_many :aws_opsworks_servers, join_table: :aws_opsworks_servers_aws_tags
  has_and_belongs_to_many :aws_app_stream_users, join_table: :aws_app_stream_users_aws_tags
  has_and_belongs_to_many :aws_gamelift_fleets, join_table: :aws_gamelift_fleets_aws_tags
  has_and_belongs_to_many :aws_route53_traffic_policies, join_table: :aws_route53_traffic_policies_aws_tags
  has_and_belongs_to_many :aws_elemental_media_live_inputs, join_table: :aws_elemental_media_live_inputs_aws_tags
  has_and_belongs_to_many :aws_elemental_media_live_channels, join_table: :aws_elemental_media_live_channels_aws_tags
  has_and_belongs_to_many :aws_pinpoint_apps, join_table: :aws_pinpoint_apps_aws_tags
  has_and_belongs_to_many :aws_kinesis_analytics_applications, join_table: :aws_kinesis_analytics_applications_aws_tags
  has_and_belongs_to_many :aws_mq_brokers, join_table: :aws_mq_brokers_aws_tags
  has_and_belongs_to_many :aws_elemental_media_store_containers, join_table: :aws_elemental_media_store_containers_aws_tags
  has_and_belongs_to_many :aws_greengrass_devices, join_table: :aws_greengrass_devices_aws_tags
  has_and_belongs_to_many :aws_snowball_jobs, join_table: :aws_snowball_jobs_aws_tags
  has_and_belongs_to_many :aws_virtual_private_cloud_vpc_endpoints, join_table: :aws_virtual_private_cloud_vpc_endpoints_aws_tags
  has_and_belongs_to_many :aws_virtual_private_cloud_vpn_connections, join_table: :aws_virtual_private_cloud_vpn_connections_aws_tags
  has_and_belongs_to_many :aws_eks_clusters, join_table: :aws_eks_clusters_aws_tags
  has_and_belongs_to_many :aws_iot_device_defender_devices, join_table: :aws_iot_device_defender_devices_aws_tags
  has_and_belongs_to_many :aws_sumerian_binaries, join_table: :aws_sumerian_binaries_aws_tags
  has_and_belongs_to_many :aws_msk_clusters, join_table: :aws_msk_clusters_aws_tags
  has_and_belongs_to_many :aws_ecr_repositories, join_table: :aws_ecr_repositories_aws_tags
  has_and_belongs_to_many :aws_neptune_clusters, join_table: :aws_neptune_clusters_aws_tags
  has_and_belongs_to_many :aws_neptune_instances, join_table: :aws_neptune_instances_aws_tags
  has_and_belongs_to_many :aws_chime_dial_in_conferences, join_table: :aws_chime_dial_in_conferences_aws_tags
  has_and_belongs_to_many :aws_chime_accounts, join_table: :aws_chime_accounts_aws_tags
  has_and_belongs_to_many :aws_datasync_tasks, join_table: :aws_datasync_tasks_aws_tags
  has_and_belongs_to_many :aws_iot_1_click_devices, join_table: :aws_iot_1_click_devices_aws_tags
  has_and_belongs_to_many :aws_firewall_manager_policies, join_table: :aws_firewall_manager_policies_aws_tags
  has_and_belongs_to_many :aws_amplify_apps, join_table: :aws_amplify_apps_aws_tags
  has_and_belongs_to_many :aws_quicksight_users, join_table: :aws_quicksight_users_aws_tags
  has_and_belongs_to_many :aws_step_functions_state_machines, join_table: :aws_step_functions_state_machines_aws_tags
  has_and_belongs_to_many :aws_fsx_backups, join_table: :aws_fsx_backups_aws_tags
  has_and_belongs_to_many :aws_fsx_file_systems, join_table: :aws_fsx_file_systems_aws_tags
  has_and_belongs_to_many :aws_global_accelerator_accelerators, join_table: :aws_global_accelerator_accelerators_aws_tags
  has_and_belongs_to_many :aws_dynamo_db_backups, join_table: :aws_dynamo_db_backups_aws_tags
  has_and_belongs_to_many :aws_transfer_for_sftp_servers, join_table: :aws_transfer_for_sftp_servers_aws_tags
  has_and_belongs_to_many :aws_cost_management_savings_plans, join_table: :aws_cost_management_savings_plans_aws_tags
  has_and_belongs_to_many :aws_security_hub_hubs, join_table: :aws_security_hub_hubs_aws_tags
  has_and_belongs_to_many :aws_cloud_map_services, join_table: :aws_cloud_map_services_aws_tags
  has_and_belongs_to_many :aws_athena_workgroups, join_table: :aws_athena_workgroups_aws_tags
  has_and_belongs_to_many :aws_document_db_instances, join_table: :aws_document_db_instances_aws_tags
  has_and_belongs_to_many :aws_document_db_clusters, join_table: :aws_document_db_clusters_aws_tags
  has_and_belongs_to_many :aws_document_db_snapshots, join_table: :aws_document_db_snapshots_aws_tags
  has_and_belongs_to_many :aws_ec2_capacity_reservations, join_table: :aws_ec2_capacity_reservations_aws_tags
  has_and_belongs_to_many :aws_aurora_clusters, join_table: :aws_aurora_clusters_aws_tags
  has_and_belongs_to_many :aws_aurora_cluster_snapshots, join_table: :aws_aurora_cluster_snapshots_aws_tags
  has_and_belongs_to_many :aws_kendra_data_sources, join_table: :aws_kendra_data_sources_aws_tags
  has_and_belongs_to_many :aws_kendra_indices, join_table: :aws_kendra_indices_aws_tags
  has_and_belongs_to_many :aws_data_exchange_data_sets, join_table: :aws_data_exchange_data_sets_aws_tags
  has_and_belongs_to_many :aws_elemental_media_connect_flows, join_table: :aws_elemental_media_connect_flows_aws_tags
  has_and_belongs_to_many :aws_elemental_media_connect_outputs, join_table: :aws_elemental_media_connect_outputs_aws_tags
  has_and_belongs_to_many :aws_elemental_media_connect_sources, join_table: :aws_elemental_media_connect_sources_aws_tags
  has_and_belongs_to_many :aws_elastic_ips, join_table: :aws_elastic_ips_aws_tags
  has_and_belongs_to_many :aws_sagemaker_notebook_instances, join_table: :aws_sagemaker_notebook_instances_aws_tags
  has_and_belongs_to_many :aws_elastic_file_systems, join_table: :aws_elastic_file_systems_aws_tags
  has_and_belongs_to_many :aws_managed_blockchain_members, join_table: :aws_managed_blockchain_members_aws_tags
  has_and_belongs_to_many :aws_managed_blockchain_nodes, join_table: :aws_managed_blockchain_nodes_aws_tags
  has_and_belongs_to_many :aws_dedicated_hosts, join_table: :aws_dedicated_hosts_aws_tags
  has_and_belongs_to_many :aws_elemental_media_convert_jobs, join_table: :aws_elemental_media_convert_jobs_aws_tags
  has_and_belongs_to_many :aws_elemental_media_convert_job_templates, join_table: :aws_elemental_media_convert_job_templates_aws_tags
  has_and_belongs_to_many :aws_eks_fargate_pods, join_table: :aws_eks_fargate_pods_aws_tags
  has_and_belongs_to_many :aws_sage_maker_batch_transform_jobs, join_table: :aws_sage_maker_batch_transform_jobs_aws_tags
  has_and_belongs_to_many :aws_sage_maker_processing_jobs, join_table: :aws_sage_maker_processing_jobs_aws_tags
  has_and_belongs_to_many :aws_sage_maker_studio_notebooks, join_table: :aws_sage_maker_studio_notebooks_aws_tags
  has_and_belongs_to_many :aws_ecs_fargate_tasks, join_table: :aws_ecs_fargate_tasks_aws_tags
  has_and_belongs_to_many :aws_nat_gateways, join_table: :aws_nat_gateways_aws_tags
  has_and_belongs_to_many :aws_kms_cmks, join_table: :aws_kms_cmks_aws_tags
  has_and_belongs_to_many :aws_transcribe_transcription_jobs, join_table: :aws_transcribe_transcription_jobs_aws_tags
  has_and_belongs_to_many :aws_bedrock_models, join_table: :aws_bedrock_models_aws_tags
  has_and_belongs_to_many :aws_security_lake_data_lakes, join_table: :aws_security_lake_data_lakes_aws_tags
  # aws_asset_generator - Please leave this comment at the bottom of the has_and_belongs_to_many relationships

  class << self
    # MySQL ignores trailing spaces in string comparison
    # So let it fetch all that it thinks match because we want indexes to be used
    # and then we filter out the one we really asked for
    def find_by_customer_id_and_key_and_value_and_customer_tag(customer_id, key, value, customer_tag)
      where(customer_id: customer_id,
            key: key,
            value: value).find { |t| t.key == key && t.value == value && t.customer_tag == customer_tag}
    end

    def find_or_create_by_customer_id_and_key_and_value_and_customer_tag(customer_id, key, value, customer_tag)
      tag = find_by_customer_id_and_key_and_value_and_customer_tag customer_id, key, value, customer_tag
      return tag if tag
      new.tap do |t|
        t.customer_id = customer_id
        t.key = key
        t.value = value
        t.save!
      end
    end
  end
end
