class InstanceAttributeHash < ActiveRecord::Base

  belongs_to :customer
  belongs_to :aws_account

  belongs_to :aws_instance

  # lookup w/o scope
  def aws_instance
    AwsInstance.unscoped {super}
  end

  def object_name
    "Instance System Attributes #{self.to_s}"
  end
end
