class AzureSubscription < ActiveRecord::Base
  scope :active, -> { where(is_active: true) }
  before_destroy { raise ActiveRecord::ReadOnlyRecord }

  belongs_to :customer

  class << self
    def model_type_id
      ModelType::AZURE_SUBSCRIPTION
    end
  end

end
