class ModelType < ActiveRecord::Base
  AWS_ACCOUNT = 2
  AWS_GROUP = 5
  AWS_IMAGE = 6
  AWS_INSTANCE = 7
  AWS_RDS_INSTANCE = 13
  AWS_SECURITY_GROUP = 15
  AWS_SNAPSHOT = 18
  AWS_USER = 25
  AWS_VOLUME = 26
  AWS_S3_BUCKET = 40
  AWS_REDSHIFT_CLUSTER = 48
  AWS_DYNAMO_DB_TABLE = 53
  AWS_CACHE_CLUSTER = 54
  INSTANCE_ATTRIBUTE_HASH = 55
  AWS_RDS_INSTANCE_RESERVATION = 60
  AWS_EMR_CLUSTER = 66
  CLOUD_FRONT_DISTRIBUTION = 111
  AWS_ROUTE53_HOSTED_ZONE = 124
  AWS_CONFIG_RULE_EVALUATION_RESULT = 130
  AWS_LAMBDA_FUNCTION = 145
  AWS_IAM_POLICY = 168
  AWS_IAM_ROLE = 169
  AWS_IAM_SERVER_CERTIFICATE = 170
  AWS_ACCOUNT_REGION_ATTRIBUTE = 173
  AWS_CLOUDTRAIL_TRAIL = 187
  AWS_ELASTIC_FILE_SYSTEM = 216
  AWS_DEDICATED_HOST = 222
  AWS_WORKSPACE = 225
  AWS_AUTO_SCALING_GROUP = 227
  AWS_KMS_CMK = 243
  AWS_NAT_GATEWAY = 211
  AWS_ELASTIC_FILE_SYSTEM = 216
  AWS_ELASTICSEARCH_DOMAIN = 219
  AWS_DEDICATED_HOST = 222
  AWS_AUTO_SCALING_GROUP = 227
  AWS_KINESIS_STREAM = 228
  AWS_SAGEMAKER_ENDPOINT = 236
  AWS_KINESIS_FIREHOSE = 240
  AWS_SAGEMAKER_NOTEBOOK_INSTANCE = 241
  AWS_DMS_REPLICATION_INSTANCE = 242
  AWS_KMS_CMK = 243
  AWS_DATA_PIPELINE_PIPELINE = 253
  AWS_SNS_TOPIC = 254
  AWS_CLOUDWATCH_LOG_GROUP = 255
  AWS_CLOUDWATCH_METRIC_FILTER = 256
  AWS_CLOUDWATCH_ALARM = 257
  AWS_CLOUD_DIRECTORY_DIRECTORY = 258
  AWS_DIRECT_CONNECT_CONNECTION = 259
  AWS_DIRECT_CONNECT_VIRTUAL_INTERFACE = 260
  AWS_COGNITO_USER_POOL = 261
  AWS_GLACIER_VAULT = 262
  AWS_KINESIS_VIDEO_STREAM = 263
  AWS_CLOUD_SEARCH_DOMAIN = 264
  AWS_CLOUDHSM_HSM = 265
  AWS_ROUTE53_HEALTH_CHECK = 266
  AWS_DYNAMO_DB_ACCELERATOR_CLUSTER = 267
  AWS_MACHINE_LEARNING_BATCH_PREDICTION = 271
  AWS_MACHINE_LEARNING_DATASOURCE = 272
  AWS_MACHINE_LEARNING_EVALUATION = 273
  AWS_MACHINE_LEARNING_ML_MODEL = 274
  AWS_API_GATEWAY_STAGE = 275
  AWS_EC2_APPLICATION_LOAD_BALANCER = 276
  AWS_EC2_NETWORK_LOAD_BALANCER = 277
  AWS_CODE_BUILD_PROJECT = 278
  AWS_DIRECTORY_SERVICE_DIRECTORY = 279
  AWS_STORAGE_GATEWAY_FILE_SHARE = 283
  AWS_STORAGE_GATEWAY_TAPE = 284
  AWS_STORAGE_GATEWAY_VOLUME_GATEWAY = 285
  AWS_IOT_ANALYTICS_CHANNEL = 286
  AWS_IOT_ANALYTICS_PIPELINE = 287
  AWS_IOT_ANALYTICS_DATASTORE = 288
  AWS_IOT_ANALYTICS_DATASET = 289
  AWS_CM_CERTIFICATE = 290
  AWS_CM_CERTIFICATE_AUTHORITY = 291
  AWS_APP_STREAM_FLEET = 292
  AWS_APP_STREAM_IMAGE_BUILDER = 293
  AWS_ALEXA_FOR_BUSINESS_DEVICE = 294
  AWS_ALEXA_FOR_BUSINESS_USER = 295
  AWS_SECRETS_MANAGER_SECRET = 296
  AWS_GLUE_DEVELOPMENT_ENDPOINT = 297
  AWS_GLUE_JOB = 298
  AWS_GLUE_CRAWLER = 299
  AWS_OPSWORKS_SERVER = 302
  AWS_GAMELIFT_FLEET = 303
  AWS_LEX_BOT = 304
  AWS_SHIELD_PROTECTION = 305
  AWS_SHIELD_SUBSCRIPTION = 306
  AWS_WAF_RULE = 307
  AWS_WAF_WEBACL = 308
  AWS_SIMPLE_EMAIL_SERVICE_DEDICATED_IP = 309
  AWS_ELEMENTAL_MEDIA_LIVE_CHANNEL = 310
  AWS_ELEMENTAL_MEDIA_LIVE_INPUT = 311
  AWS_KINESIS_ANALYTICS_APPLICATION = 312
  AWS_APP_STREAM_USER = 313
  AWS_ROUTE53_TRAFFIC_POLICY = 314
  AWS_MQ_BROKER = 315
  AWS_PINPOINT_APP = 316
  AWS_ELEMENTAL_MEDIA_STORE_CONTAINER = 317
  AWS_SNOWBALL_JOB = 318
  AWS_GREENGRASS_DEVICE = 319
  AWS_SUMERIAN_BINARY = 323
  AWS_IOT_DEVICE_DEFENDER_DEVICE = 324
  AWS_EKS_CLUSTER = 325
  AWS_VIRTUAL_PRIVATE_CLOUD_VPC_ENDPOINT = 326
  AWS_VIRTUAL_PRIVATE_CLOUD_VPN_CONNECTION = 327
  AWS_ECR_REPOSITORY = 339
  AWS_CHIME_DIAL_IN_CONFERENCE = 340
  AWS_MSK_CLUSTER = 341
  AWS_NEPTUNE_CLUSTER = 342
  AWS_NEPTUNE_INSTANCE = 343
  AWS_CHIME_ACCOUNT = 344
  AWS_COST_MANAGEMENT_SAVINGS_PLAN = 364
  AWS_DATASYNC_TASK = 366
  AWS_FIREWALL_MANAGER_POLICY = 367
  AWS_AMPLIFY_APP = 368
  AWS_QUICKSIGHT_USER = 369
  AWS_FSX_BACKUP = 370
  AWS_FSX_FILE_SYSTEM = 371
  AWS_STEP_FUNCTIONS_STATE_MACHINE = 372
  AWS_GLOBAL_ACCELERATOR_ACCELERATOR = 373
  AWS_DYNAMO_DB_BACKUP = 374
  AWS_TRANSFER_FOR_SFTP_SERVER = 375
  AWS_CLOUD_MAP_SERVICE = 386
  AWS_SECURITY_HUB_HUB = 387
  AWS_DOCUMENT_DB_CLUSTER = 388
  AWS_DOCUMENT_DB_INSTANCE = 389
  AWS_DOCUMENT_DB_SNAPSHOT = 390
  AWS_AURORA_CLUSTER = 391
  AWS_AURORA_CLUSTER_SNAPSHOT = 392
  AWS_ATHENA_WORKGROUP = 393
  AWS_DATA_EXCHANGE_DATA_SET = 394
  AWS_ELEMENTAL_MEDIA_CONNECT_FLOW = 395
  AWS_ELEMENTAL_MEDIA_CONNECT_OUTPUT = 396
  AWS_ELEMENTAL_MEDIA_CONNECT_SOURCE = 397
  AWS_EC2_CAPACITY_RESERVATION = 398
  AWS_KENDRA_DATA_SOURCE = 399
  AWS_KENDRA_INDEX = 400
  AWS_SQS_QUEUE = 407
  AWS_ELEMENTAL_MEDIA_CONVERT_JOB = 408
  AWS_ELEMENTAL_MEDIA_CONVERT_JOB_TEMPLATE = 409
  AWS_MANAGED_BLOCKCHAIN_NODE = 410
  AWS_MANAGED_BLOCKCHAIN_MEMBER = 411
  AWS_SAGE_MAKER_BATCH_TRANSFORM_JOB = 415
  AWS_SAGE_MAKER_PROCESSING_JOB = 416
  AWS_SAGE_MAKER_STUDIO_NOTEBOOK = 417
  AWS_EKS_FARGATE_POD = 418
  AWS_ECS_FARGATE_TASK = 419
  AWS_SECURITY_LAKE_DATA_LAKE = 493

  AZURE_VM = 119
  AZURE_SUBSCRIPTION = 143
  AZURE_VIRTUAL_NETWORK_SECURITY_GROUP = 181
  AZURE_IP_ADDRESS = 183
  AZURE_VM_SCALE_SET = 186
  AZURE_SQL_SERVER = 188
  AZURE_SQL_DATABASE = 189
  AZURE_CACHE_REDIS = 191
  AZURE_VIRTUAL_NETWORK_GATEWAY = 196
  AZURE_APP_SERVICE_PLAN = 197
  AZURE_SERVICE_BUS_NAMESPACE = 198
  AZURE_SQL_DATA_WAREHOUSE = 205
  AZURE_STOR_SIMPLE_DEVICE_MANAGER = 206
  AZURE_EXPRESS_ROUTE_CIRCUIT = 209
  AZURE_CDN_PROFILE = 210
  AZURE_SNAPSHOT = 212
  AZURE_MANAGED_DISK = 214
  AZURE_APP_INSIGHT = 215
  AZURE_DOCUMENT_DB = 217
  AZURE_KEY_VAULT = 218
  AZURE_APPLICATION_GATEWAY = 223
  AZURE_APP_SERVICE_ENVIRONMENT = 226
  AZURE_IOT_HUB = 360
  AZURE_SQL_MANAGED_INSTANCE = 361
  AZURE_POSTGRESQL_SERVER = 413
  AZURE_DATABRICKS_WORKSPACE = 414
  AZURE_MYSQL_SERVER = 422
  AZURE_RECOVERY_SERVICES_VAULT = 202
  AZURE_HD_INSIGHT_CLUSTER = 203
  AZURE_SEARCH_SERVICE = 204
  AZURE_STORAGE = 185
  AZURE_APP_SERVICE = 207
  AZURE_LOG_ANALYTICS_WORKSPACE = 208
  AZURE_EVENT_HUB_NAMESPACE = 384
end
