module Gdas::ArtifactAnalyzers::Aws

  class EcsXformAnalyzer < AwsXformAnalyzer

    class << self
      extend ::Memoist

      def required_columns
        super.merge(
          resource_id: 'SyntheticId',
          resource_id_sha1: 'SyntheticIdSha1'
        ).freeze
      end
      memoize :required_columns, :identifier => :ecs_xform_analyzer

      def supported_artifacts
        ['gdas_ecs_artifact_with_metadata']
      end
    end
  end
end
