module Gdas::Assets::Aws::Route53
  module Context
    extend ::ActiveSupport::Concern

    included do
      class << self
        def service
          'route53'
        end
      end

      def supported?
        !is_govcloud
      end
    end
  end
end
