# frozen_string_literal: true
# AWS SageMaker is a service that allows users to "Build, train, and deploy
# machine learning models & algorithms"
module Gdas::Assets::Aws::SageMaker
  # SageMaker common context for collectors
  module Context
    extend ::ActiveSupport::Concern

    included do
      # Context.service => 'sage_maker'
      class << self
        def service
          'sage_maker'
        end
      end
    end
  end
end
